
/* Exercise 2

   spin -a -f "!([](prop_done -> prop_value)" e2.pml
   do NOT negate the property if you are using JSpin / the web interface
*/

#define prop_done (done == 1)
#define prop_value (value == 100)

chan com = [0] of { byte };

byte value = 0;
bool done  = 0;

ltl prop {[] (prop_done -> prop_value)}

// OR as suggested during the exercise session:
// ltl prop {<> prop_value}

proctype p() {
  
  byte i = 0;

  do 
  :: if 
     :: i >= 5 -> break 
     :: else -> printf("Doing something else\n");
     	        i ++
     fi
  :: com ? value;
     printf("p received: %d\n",value)
  od;
 
  done = 1

}



init {
     atomic {
        run p();
     }

     end: com ! 100;

}

